<template>
  <div class="table-box">
    <div class="bg-white pt-2 pl-2">
      <el-tabs v-model="activeName" class="demo-tabs" @tab-click="handleClick">
        <el-tab-pane
          :label="item.label"
          :name="item.value"
          v-for="(item, index) in tabs"
          :key="index"
        >
          <template #label>
            <div>
              {{ item.label }}
              <span style="font-size: 20px; font-weight: bold">{{ item.msg }}</span>
            </div>
          </template>
        </el-tab-pane>
      </el-tabs>
    </div>
    <div>
      <ProTable
        :config="config"
        ref="caseLRef"
        :api="getTrackRecord"
        :selectdList="selectdList"
        :paramCallback="paramCallback"
      >
        <!-- 表格 header 按钮 -->
        <template #left_buttons>
          <el-button
            type="primary"
            v-if="activeName === 'un_audit'"
            @click="audit"
            v-permission="'send_audio'"
            :disabled="!selectdList || selectdList.length === 0"
            >发起稽核</el-button
          >
        </template>
      </ProTable>
    </div>
    <callDrawer ref="callDrawerRef" @success="query()" :mode="callMode" />
    <el-image-viewer :url-list="srcList" v-if="RefImage" @close="RefImage = false" />
  </div>
</template>

<script setup name="case-audit" lang="jsx">
  import { Download } from '@element-plus/icons-vue';
  import { inject } from 'vue';
  import { computed } from 'vue';
  import callDrawer from './components/callDrawer.vue';
  import { ElMessageBox, ElMessage, ElButton, ElTag } from 'element-plus';
  import { onMounted } from 'vue';
  import { getAppEnvConfig } from '@/utils/env';
  import { getTrackRecord, getTrackRecordAuditTotal } from '@/api/property';
  import { batchSave } from '@/api/audit';
  import { useUserStore } from '@/stores/modules/user';
  import { getTenantPage } from '@/api/tenant';
  import { watch } from 'vue';
  import { useDict } from '@/hooks/useDict';
  const { PhoneResultStatus, ReduceType, FlowStatus, FollowStatus, AuditStatus, CaseStatus } =
    useDict(
      'PhoneResultStatus',
      'ReduceType',
      'FlowStatus',
      'FollowStatus',
      'AuditStatus',
      'CaseStatus'
    );
  const envs = getAppEnvConfig();
  const { userInfo } = useUserStore();

  import { reactive, ref } from 'vue';
  const downloadfile = inject('download');

  const allocationModalRef = ref();
  const caseLRef = ref();
  const selectdList = ref([]);
  const tabs = ref([]);
  const callDrawerRef = ref();
  const srcList = ref([]);
  const RefImage = ref(false);
  const onCheckboxChange = (row) => {
    selectdList.value = row.records;
  };

  const activeName = ref('un_audit');
  watch(
    () => AuditStatus.value,
    (newValue, oldValue) => {
      if (AuditStatus.value[0]) {
        activeName.value = AuditStatus.value[0].value
        query()
      }
    }
  );
  const callMode = ref('');
  const paramCallback = (param) => {
    const obj = JSON.parse(JSON.stringify(param));
    // if (userInfo.id) {
    //   obj['createBy'] = userInfo.id;
    // }
    obj['auditStatus'] = activeName.value;
    if (obj['trackTime']) {
      if (obj['trackTime'][0]) obj['trackTimeBegin'] = obj['trackTime'][0];
      if (obj['trackTime'][1]) obj['trackTimeEnd'] = obj['trackTime'][1];
      delete obj['trackTime'];
    }
    if (obj['nextTime']) {
      if (obj['nextTime'][0]) obj['nextTrackTimeBegin'] = obj['nextTime'][0];
      if (obj['nextTime'][1]) obj['nextTrackTimeEnd'] = obj['nextTime'][1];
      delete obj['nextTime'];
    }
    setTimeout(
      () => {
        const arr = JSON.parse(JSON.stringify(AuditStatus.value));

        getTrackRecordAuditTotal({ ...obj, auditStatus: null })
          .then((res) => {
            if (res.success) {
              arr.forEach((item) => {
                const tt = res.result.find((v) => v.auditStatus === item.value);
                if (tt) {
                  item['msg'] = tt.number;
                } else {
                  item['msg'] = 0;
                }
              });
              tabs.value = arr;
            } else {
              tabs.value = arr;
            }
          })
          .catch((e) => {
            tabs.value = arr;
          });
      },
      AuditStatus.value && AuditStatus.value.length ? 100 : 1000
    );
    // obj['voices'] = 'Y'
    // obj['images'] = 'Y'
    // obj['notes'] = 'Y'
    // obj['others'] = 'Y'
    return obj;
  };
  const callTelephone = (row, type) => {
    callMode.value = type;
    callDrawerRef.value.openModal(JSON.parse(JSON.stringify(row)));
  };
  const handleClick = () => {
    setTimeout(() => {
      query();
    }, 300);
  };
  const onCheckboxAll = (flag) => {
    if (flag.checked) {
      selectdList.value = flag.records;
    } else {
      selectdList.value = [];
    }
  };
  const config = computed(() => {
    return {
      rowStyle({ row }) {
        if (row.auditDesc === 'time_out') {
          return {
            backgroundColor: 'rgb(242,217,217)',
          };
        }
      },
      columns: [
        { type: 'checkbox', title: '', width: 60, fixed: 'left' },
        { field: 'id', title: '跟进记录ID', showOverflow: 'tooltip', width: 90 },
        {
          field: 'caseId',
          title: '案件ID',
          showOverflow: 'tooltip',
          width: 80,
          search: { el: 'input', props: { clearable: true }, labelWidth: 105 },
          slots: {
            default: ({ row }) => {
              return <>{Array.from(new Set(row.loans.map((v) => v.caseId))).join(',')}</>;
            },
          },
        },
        {
          field: 'trackTime',
          title: '跟进日期',
          showOverflow: 'tooltip',
          width: 100,
          search: {
            el: 'date-picker',
            props: { type: 'datetimerange', valueFormat: 'YYYY-MM-DD HH:mm:ss' },
            labelWidth: 105,
          },
        },
        {
          title: 'CPE',
          showOverflow: 'tooltip',
          width: 60,
          slots: {
            default: ({ row }) => {
              return <>{row?.cpe?.username}</>;
            },
          },
          search: { el: 'input', props: { clearable: true }, key: 'cpeName', labelWidth: 105 },
        },
        {
          showOverflow: 'tooltip',
          slots: {
            default: ({ row }) => {
              return <>{row?.tenant?.name}</>;
            },
          },
          enum: () => getTenantPage({ current: 1, size: 999999999, status: 'enable' }),
          search: { el: 'select', props: { filterable: true,clearable: true }, key: 'tenantId', labelWidth: 105 },
          fieldNames: { label: 'name', value: 'id' },
          title: '调解中心',
          width: 100,
        },
        {
          field: 'nextTime',
          title: '下次跟进时间',
          showOverflow: 'tooltip',
          width: 110,
          search: {
            el: 'date-picker',
            props: { type: 'daterange', valueFormat: 'YYYY-MM-DD' },
            labelWidth: 105,
          },
        },
        {
          field: 'guarantor.name',
          title: '联系人姓名',
          showOverflow: 'tooltip',
          width: 110,
          search: {
            el: 'input',
            props: { clearable: true },
            key: 'guarantorName',
            labelWidth: 105,
          },
        },
        {
          field: 'guarantor.phone',
          title: '联系人号码',
          showOverflow: 'tooltip',
          width: 110,
          search: {
            el: 'input',
            props: { clearable: true },
            key: 'guarantorPhone',
            labelWidth: 105,
          },
          labelWidth: 105,
        },
        {
          field: 'followStatus',
          title: '拨打跟进结果',
          showOverflow: 'tooltip',
          width: 120,
          enum: FollowStatus,
          search: {
            el: 'select',
            props: { filterable: true, multiple: true, 'collapse-tags': true },
            labelWidth: 105
          },
          fieldNames: { label: 'label', value: 'value' },
          slots: {
            default: ({ row }) => {
              return (
                <>
                  {row.followStatus
                    ? FollowStatus.value?.find((v) => v.value === row.followStatus)?.label
                    : ''}
                </>
              );
            },
          },
        },
        {
          field: 'phoneResultStatus',
          title: '拨打处置状态',
          showOverflow: 'tooltip',
          width: 120,
          enum: PhoneResultStatus,
          search: { el: 'select', props: { filterable: true,clearable: true }, labelWidth: 105 },
          fieldNames: { label: 'label', value: 'value' },
          slots: {
            default: ({ row }) => {
              return (
                <>
                  {row.phoneResultStatus
                    ? PhoneResultStatus.value?.find((v) => v.value === row.phoneResultStatus)?.label
                    : ''}
                </>
              );
            },
          },
        },
        {
          field: 'trackRecord.auditStatus',
          title: '稽核状态',
          showOverflow: 'tooltip',
          width: 80,
          slots: {
            default: ({ row }) => {
              return (
                <>
                  {row.auditStatus
                    ? AuditStatus.value?.find((v) => v.value === row.auditStatus)?.label
                    : ''}
                </>
              );
            },
          },
        },
        {
          field: 'remark',
          title: '备注',
          showOverflow: 'tooltip',
          width: 80,
          search: { el: 'input', props: { clearable: true }, labelWidth: 105 },
        },
        {
          field: 'voices',
          title: '通话录音',
          showOverflow: 'tooltip',
          width: 80,
          slots: {
            default: ({ row, rowIndex }) => {
              if (row.voices && row.voices.length > 0) {
                return (
                  <>
                    {row.voices.map((item, index) => (
                      <el-icon>
                        <Download onClick={() => download(item)} style="cursor: pointer;" />
                      </el-icon>
                    ))}
                  </>
                );
              }
            },
          },
        },
        {
          field: 'code',
          title: '微信图片附件',
          showOverflow: 'tooltip',
          width: 100,
          slots: {
            default: ({ row, rowIndex }) => {
              if (row.images && row.images.length > 0) {
                return (
                  <>
                    <div className="flex justify-center">
                      <ElButton onClick={() => preview(row, 'images')} link type="primary">
                        查看
                      </ElButton>
                    </div>
                  </>
                );
              }
            },
          },
        },
        {
          field: 'sendAuditTime',
          title: '稽核发起时间',
          showOverflow: 'tooltip',
          width: 130,
        },
        {
          field: 'endAuditTime',
          title: '稽核结束时间',
          showOverflow: 'tooltip',
          width: 130,
        },

        {
          field: 'status',
          title: '超时状态',
          width: 100,
          showOverflow: 'tooltip',
          // search: { el: 'select', props: { clearable: true }, labelWidth: 105 },
          slots: {
            default: ({ row }) => {
              return (
                <ElTag type={row.auditDesc == 'time_out' ? 'danger' : 'primary'}>
                  {row.auditDesc == 'time_out' ? '已超时' : '正常'}
                </ElTag>
              );
            },
          },
        },
        {
          field: 'code',
          title: '短信图片附件',
          showOverflow: 'tooltip',
          width: 100,
          slots: {
            default: ({ row, rowIndex }) => {
              if (row.notes && row.notes.length > 0) {
                return (
                  <>
                    <div className="flex justify-center">
                      <ElButton onClick={() => preview(row, 'notes')} link type="primary">
                        查看
                      </ElButton>
                    </div>
                  </>
                );
              }
            },
          },
        },
        {
          field: 'code',
          title: '其他图片附件',
          showOverflow: 'tooltip',
          width: 100,
          slots: {
            default: ({ row, rowIndex }) => {
              if (row.others && row.others.length > 0) {
                return (
                  <>
                    <div className="flex justify-center">
                      <ElButton onClick={() => preview(row, 'others')} link type="primary">
                        查看
                      </ElButton>
                    </div>
                  </>
                );
              }
            },
          },
        },
        {
          field: 'code',
          title: '操作',
          width: 150,
          visible: activeName.value === 'audit' || activeName.value === 'rejected' ? true : false,
          slots: {
            default: ({ row, rowIndex }) => {
              if (activeName.value === 'audit' || activeName.value === 'rejected') {
                return (
                  <>
                    <ElButton type="primary" onClick={() => callTelephone(row, 'handle')}>
                      补充跟进材料
                    </ElButton>
                  </>
                );
              }
            },
          },
        },
      ],
      onCheckboxChange: onCheckboxChange,
      onCheckboxAll: onCheckboxAll,
    };
  });
  const preview = (item, type) => {
    const list = [];
    item[type].forEach((v) => {
      list.push(envs.VITE_GLOB_API_URL_PREFIX + '/sys/static/' + v);
    });
    RefImage.value = true;
    srcList.value = list;
  };
  const download = (item) => {
    const name = item.slice(item.lastIndexOf('/') + 1, item.length);
    downloadfile('/sys/static/' + item, {}, name);
  };
  const audit = async (row) => {
    const list = caseLRef.value.element.getCheckboxRecords();
    if (!list.length) return;
    await ElMessageBox.confirm('是否确认发起稽核勾选项?', '提示', {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    });
    const ids = list.map((v) => v.id).join(',');
    await batchSave({ ids: ids });

    ElMessage({
      type: 'success',
      message: '稽核申请发起成功！',
      plain: true,
    });
    query();
  };
  const query = () => {
    caseLRef.value?.search();
  };

  onMounted(() => {
    query();
  });
</script>
